<template>
  <div class="checkbox-component">
    <input
      type="checkbox"
      class="checkbox"
      :checked="done"
      @change="onChange"
    >
    <span class="checkmark-container"><span class="tick-mark"></span></span>
  </div>
</template>

<script>
export default {
  name: 'checkbox-component',
  props: {
    done: {
      type: Boolean,
      required: true
    }
  },
  methods: {
    onChange (event) {
      this.$emit('change', event.target.value)
    }
  }
}
</script>

<style scoped>
.checkbox-component {
  width: 25px;
  height: 25px;
  position: relative;
  border-radius: 50%;
  transition: all .3s ease-in;
}

.checkbox-component:hover {
  box-shadow: 0 0 0 15px rgba(210, 135, 0, 0.5);
}

.checkbox {
  position: absolute;
  height: 100%;
  width: 100%;
  top: 0;
  left: 0;
  opacity: 0;
  cursor: pointer;
  z-index: 3;
}

.checkmark-container {
  border: 1px solid rgba(210, 135, 0, 0.5);
  background-color: #fff;
  position: absolute;
  width: 100%;
  height: 100%;
  top: 0;
  left: 0;
  z-index: 1;
}

.checkbox:checked ~ .checkmark-container {
  background-color: orange;
}

.tick-mark {
  position: relative;
  display: block;
  padding-top: 18px;
  width: 15px;
  height: 15px;
}

.tick-mark::before {
  position: absolute;
  left: 0;
  top: 50%;
  height: 50%;
  width: 3px;
  background-color: #fff;
  content: "";
  transform: translateX(10px) rotate(-45deg);
  transform-origin: left bottom;
}

.tick-mark::after {
  position: absolute;
  left: 0;
  bottom: 0;
  height: 3px;
  width: 100%;
  background-color: #fff;
  content: "";
  transform: translateX(10px) rotate(-45deg);
  transform-origin: left bottom;
}

.checkbox:checked ~ .tick-mark {
  display: block;
}
</style>
